# Dynoga

## Disclaimer

**Dynoga** is a lightweight library to use DynamoDB with JavaScript objects.

We use CRUD naming for easy matching with [Backbone.ioBind](https://github.com/logicalparadox/backbone.iobind)

## How to use

### Initialize


```
Dynoga = require "dynoga"

db = new Dynoga
  endpoint: config.dynamoDB.endpoint
  accessKeyId: config.dynamoDB.accessKeyId
  secretAccessKey: config.dynamoDB.secretAccessKey
  region: config.dynamoDB.region
```

### Create an item


```
db.create "mytable", item, (err, model) ->
  console.log err if err
  console.log model
```

### Read an item

**keys**: Key/value object, a hash is mandatory

```
db.read "mytable", keys, (err, model) ->
  console.log err if err
  console.log model
```


### Update an item

```
db.update "mytable", key, item, (err, model) ->
  console.log err if err
  console.log model
```

### Delete an item

```
db.delete "mytable", key, (err, model) ->
  console.log err if err
  console.log model
```
