typeUtil = require "./typeUtil"
AWS = require "aws-sdk"
_ = require "lodash"

class Dynoga
  constructor: (options) ->
    @dynamo = new AWS.DynamoDB options

  create: (table, item, callback) ->
    dynamoItem = typeUtil.packObjectOrArray item

    @dynamo.putItem
      TableName: table
      Item: dynamoItem
      (err, data) ->
        callback err, item

  read: (table, objects, callback) ->
    objectsLength = _.toArray(objects).length
    dynamoObjects = typeUtil.objectToQuery objects

    @dynamo.query
      TableName: table
      KeyConditions: dynamoObjects
      (err, data) ->
        result = typeUtil.unpackObjectOrArray data
        if objectsLength is 2 then result = result[0]
        callback err, result

  update: (table, key, item, callback) ->
    dynamoKey = typeUtil.packObjectOrArray key
    dynamoItem = typeUtil.formatForUpdate item

    @dynamo.updateItem
      TableName: table
      Key: dynamoKey
      AttributeUpdates: dynamoItem
      (err, data) =>
        if err then callback err
        @read table, key, (err, item) ->
          callback err, item

  delete: (table, key, callback) ->
    dynamoKey = typeUtil.packObjectOrArray key

    @read table, key, (err, item) =>
      @dynamo.deleteItem
        TableName: table
        Key: dynamoKey
        (err, data) ->
          callback err, item

module.exports = Dynoga
